Loading...
Searching...
No Matches
_starpu_machine_topology Struct Reference

## Data Fields

unsigned | nworkers
unsigned | ncombinedworkers
unsigned | nsched_ctxs
hwloc_topology_t | hwtopology
hwloc_bitmap_t | log_cpuset
hwloc_bitmap_t | log_coreset
struct starpu_tree * | tree
unsigned | nhwpus
unsigned | firstusedpu
unsigned | nusedpus
unsigned | nhwdevices [STARPU_NARCH]
unsigned | nhwworker [STARPU_NARCH][STARPU_NMAXDEVS]
unsigned | ndevices [STARPU_NARCH]
unsigned | nworker [STARPU_NARCH][STARPU_NMAXDEVS]
int | devid [STARPU_NARCH][STARPU_NMAXDEVS]
int | cuda_th_per_stream
int | cuda_th_per_dev
int | hip_th_per_stream
int | hip_th_per_dev
unsigned | workers_bindid [STARPU_NMAXWORKERS]
unsigned | workers_nbindid
unsigned | workers_devid [STARPU_NARCH][STARPU_NMAXWORKERS]

## Field Documentation

## nworkers

unsigned _starpu_machine_topology::nworkers

Total number of workers.

## ncombinedworkers

unsigned _starpu_machine_topology::ncombinedworkers

Total number of combined workers.

## nsched_ctxs

unsigned _starpu_machine_topology::nsched_ctxs

## hwtopology

hwloc_topology_t _starpu_machine_topology::hwtopology

Topology as detected by hwloc.

## log_cpuset

hwloc_bitmap_t _starpu_machine_topology::log_cpuset

## log_coreset

hwloc_bitmap_t _starpu_machine_topology::log_coreset

## tree

struct starpu_tree* _starpu_machine_topology::tree

custom hwloc tree

## nhwpus

unsigned _starpu_machine_topology::nhwpus

Total number of PUs (i.e. threads), as detected by the topology code. May be different from the actual number of CPU workers.

## firstusedpu

unsigned _starpu_machine_topology::firstusedpu

First PU to be used. May be different from 0 for administrative reasons (e.g. from job scheduler).

## nusedpus

unsigned _starpu_machine_topology::nusedpus

Number of PUs (i.e. threads) to be used. May be different from nhwpus for administrative reasons (e.g. from job scheduler).

## nhwdevices

unsigned _starpu_machine_topology::nhwdevices[STARPU_NARCH]

Total number of devices, as detected. May be different from the actual number of devices run by StarPU.

## nhwworker

unsigned _starpu_machine_topology::nhwworker[STARPU_NARCH][STARPU_NMAXDEVS]

Total number of worker for each device, as detected. May be different from the actual number of workers run by StarPU.

## ndevices

unsigned _starpu_machine_topology::ndevices[STARPU_NARCH]

Actual number of devices used by StarPU.

## nworker

unsigned _starpu_machine_topology::nworker[STARPU_NARCH][STARPU_NMAXDEVS]

Number of worker per device

## devid

int _starpu_machine_topology::devid[STARPU_NARCH][STARPU_NMAXDEVS]

Device ids actually used

## cuda_th_per_stream

int _starpu_machine_topology::cuda_th_per_stream

Whether we should have one thread per stream

## cuda_th_per_dev

int _starpu_machine_topology::cuda_th_per_dev

Whether we should have one thread per device

## hip_th_per_stream

int _starpu_machine_topology::hip_th_per_stream

Whether we should have one thread per stream (for hip)

## hip_th_per_dev

int _starpu_machine_topology::hip_th_per_dev

Whether we should have one thread per device (for hip)

## workers_bindid

unsigned _starpu_machine_topology::workers_bindid[STARPU_NMAXWORKERS]

Indicates the successive logical PU identifier that should be used to bind the workers. It is either filled according to the user's explicit parameters (from starpu_conf) or according to the STARPU_WORKERS_CPUID env. variable. Otherwise, a round-robin policy is used to distributed the workers over the cores.

## workers_nbindid

unsigned _starpu_machine_topology::workers_nbindid

Indicates how many different values there are in _starpu_machine_topology::workers_bindid, i.e. the length of the cycle of the values there.

## workers_devid

unsigned _starpu_machine_topology::workers_devid[STARPU_NARCH][STARPU_NMAXWORKERS]

Indicates the successive device identifiers that should be used by the driver. It is either filled according to the user's explicit parameters (from starpu_conf) or according to the corresponding env. variable. Otherwise, they are taken in ID order.

The documentation for this struct was generated from the following file:

- workers.h